#include <math.h>
#include <string.h>
#include <iostream>
#include <fstream>
#include <stdlib.h>
using namespace std;

const int MAXS = 100;
const int MAXP = 200;

enum Type {CAFE, RESTAURANT, STATION, HOTEL, MUSEUM};

struct Coord {
	double x;
	double y;
};

struct POI {
	Coord coord;
	Type type;
	char name[MAXS];
	int stars;
};

struct Map {
	POI pois[MAXP];
	int numPois;
};


bool findCloser(const Map* pm, const Coord c, POI* pp);
bool saveByCategory(const Map* pm, const char fn[]);
bool distances(const Map* pm, const char name1[], const char name2[], double* euc, double* man);
int remove(Map* pm, int s);
void draw(const Map* pm);

void menu(){
	cout <<"-------------------" << endl;
	cout << "1) find closer" << endl;
	cout << "2) save by cat." << endl;
	cout << "3) distances" << endl;
	cout << "4) remove" << endl;
	cout << "5) draw" << endl;
	cout << "6) exit" << endl;
	cout << "? ";
}

Coord readCoord(){
	Coord c;
	cout << "x? ";
	cin >> c.x;
	cout << "y? ";
	cin >> c.y;
	return c;
}

bool fill(Map* pm){
  POI poi;
  fstream ff;
  ff.open("input.txt");
  if(!ff) 
    return false;
  char c;
  while(ff >> poi.name >> poi.coord.x >> poi.coord.y >> c >> poi.stars) {
    switch(c) {
      case 'C': poi.type = CAFE; break;
      case 'S': poi.type = STATION; break;
      case 'R': poi.type = RESTAURANT; break;
      case 'M': poi.type = MUSEUM; break;
      case 'H': poi.type = HOTEL; break;
    }
    pm->pois[pm->numPois] = poi;
    pm->numPois++;
  }
  return true;
}

int main(){
  Map map;
  map.numPois = 0;

  char choice;
  bool res;
  Coord cc;
  POI pp;
  int st, q;
  double d1, d2;
  char n1[MAXS], n2[MAXS];
  if(fill(&map)) {
    cout << "Map filled:" << endl;
    system("type input.txt");
  } else {
    cout << "I can't fill the map" << endl;
  }
  while(true) {
    menu();
    cin >> choice;
    switch(choice) {
      case '1':
        cc = readCoord();
        res = findCloser(&map, cc, &pp);
        if(res) {
          cout << "Closer POI: " << pp.name << endl;
        } else {
          cout << "Map is empty" << endl;
        }
        break;
      case '2':
        res = saveByCategory(&map, "output.txt");
        if(res) {
          cout << "File content:" << endl;
          system("type output.txt");
        } else {
          cout << "Problem..." << endl;
        }
        break;
      case '3':
        cout << "Name 1? ";
        cin >> n1;
        cout << "Name 2? ";
        cin >> n2;
        res = distances(&map, n1, n2, &d1, &d2);
        if(res) {
          cout << "Euclidean distance: " << d1 << endl;
          cout << "Manhattan distance: " << d2 << endl;
        } else {
          cout << "Map is empty" << endl;
        }
        break;
      case '4':
        cout << "Stars? ";
        cin >> st;
        q = remove(&map, st);
        cout << q << " POIs have been removed" << endl;
        break;
      case '5':
        draw(&map);
        break;  
      case '6':
        return 0;
    }	
  }
}
